Index: sansmodels/src/sans/models/c_extensions/spheresld.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/spheresld.h	(revision 0164899a491d20467a714225f7ea955c852265f3)
+++ sansmodels/src/sans/models/c_extensions/spheresld.h	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -0,0 +1,177 @@
+#if !defined(o_h)
+#define sphere_sld_h
+
+/**
+ * Structure definition for sphere parameters
+ */
+ //[PYTHONCLASS] = SphereSLDModel
+ //[DISP_PARAMS] = thick_inter0
+ //[DESCRIPTION] =<text>Calculate neutron reflectivity using the Parratt iterative formula
+ //				Parameters:
+ //				background:background
+ //				scale: scale factor
+ //				sld_core0: the SLD of the substrate
+ //				sld_solv: the SLD of the incident medium
+ //					or superstrate
+ //				sld_flatN: the SLD of the flat region of
+ //					the N'th layer
+ //				thick_flatN: the thickness of the flat
+ //					region of the N'th layer
+ //				func_interN: the function used to describe
+ //					the interface of the N'th layer
+ //				nu_interN: the coefficient for the func_interN
+ //				thick_interN: the thickness of the interface
+ //					of the N'th layer
+ //				Note: the layer number starts to increase
+ //					from the bottom (substrate) to the top.
+ //		</text>
+ //[FIXED]=  <text></text>
+ //[NON_FITTABLE_PARAMS]= <text>n_shells;func_inter0;func_inter1;func_inter2;func_inter3;func_inter4;func_inter5;func_inter5;func_inter7;func_inter8;func_inter9;func_inter10 </text>
+ //[ORIENTATION_PARAMS]= <text> </text>
+
+typedef struct {
+	/// number of shells
+	//  [DEFAULT]=n_shells=1
+	int n_shells;
+    /// Scale factor
+    //  [DEFAULT]=scale= 1.0
+	double scale;
+    ///	thick_inter0 [A]
+    //  [DEFAULT]=thick_inter0=50.0 [A]
+	double thick_inter0;
+	///	func_inter0
+	//  [DEFAULT]=func_inter0= 0
+	double func_inter0;
+	///	sld_core0 [1/A^(2)]
+	//  [DEFAULT]=sld_core0= 2.07e-6 [1/A^(2)]
+	double sld_core0;
+	///	sld_solv [1/A^(2)]
+	//  [DEFAULT]=sld_solv= 1.0e-6 [1/A^(2)]
+	double sld_solv;
+	/// Background
+	//  [DEFAULT]=background=0
+	double background;
+
+    //  [DEFAULT]=sld_flat1=4.0e-06 [1/A^(2)]
+    double sld_flat1;
+    //  [DEFAULT]=sld_flat2=3.5e-06 [1/A^(2)]
+    double sld_flat2;
+    //  [DEFAULT]=sld_flat3=4.0e-06 [1/A^(2)]
+    double sld_flat3;
+    //  [DEFAULT]=sld_flat4=3.5e-06 [1/A^(2)]
+    double sld_flat4;
+    //  [DEFAULT]=sld_flat5=4.0e-06 [1/A^(2)]
+    double sld_flat5;
+    //  [DEFAULT]=sld_flat6=3.5e-06 [1/A^(2)]
+    double sld_flat6;
+    //  [DEFAULT]=sld_flat7=4.0e-06 [1/A^(2)]
+    double sld_flat7;
+    //  [DEFAULT]=sld_flat8=3.5e-06 [1/A^(2)]
+    double sld_flat8;
+    //  [DEFAULT]=sld_flat9=4.0e-06 [1/A^(2)]
+    double sld_flat9;
+    //  [DEFAULT]=sld_flat10=3.5e-06 [1/A^(2)]
+    double sld_flat10;
+
+    //  [DEFAULT]=thick_inter1=50.0 [A]
+    double thick_inter1;
+    //  [DEFAULT]=thick_inter2=50.0 [A]
+    double thick_inter2;
+    //  [DEFAULT]=thick_inter3=50.0 [A]
+    double thick_inter3;
+    //  [DEFAULT]=thick_inter4=50.0 [A]
+    double thick_inter4;
+    //  [DEFAULT]=thick_inter5=50.0 [A]
+    double thick_inter5;
+    //  [DEFAULT]=thick_inter6=50.0 [A]
+    double thick_inter6;
+    //  [DEFAULT]=thick_inter7=50.0 [A]
+    double thick_inter7;
+    //  [DEFAULT]=thick_inter8=50.0 [A]
+    double thick_inter8;
+    //  [DEFAULT]=thick_inter9=50.0 [A]
+    double thick_inter9;
+    //  [DEFAULT]=thick_inter10=50.0 [A]
+    double thick_inter10;
+
+    //  [DEFAULT]=thick_flat1=100 [A]
+    double thick_flat1;
+    //  [DEFAULT]=thick_flat2=100 [A]
+    double thick_flat2;
+    //  [DEFAULT]=thick_flat3=100 [A]
+    double thick_flat3;
+    //  [DEFAULT]=thick_flat4=100 [A]
+    double thick_flat4;
+    //  [DEFAULT]=thick_flat5=100 [A]
+    double thick_flat5;
+    //  [DEFAULT]=thick_flat6=100 [A]
+    double thick_flat6;
+    //  [DEFAULT]=thick_flat7=100 [A]
+    double thick_flat7;
+    //  [DEFAULT]=thick_flat8=100 [A]
+    double thick_flat8;
+    //  [DEFAULT]=thick_flat9=100 [A]
+    double thick_flat9;
+    //  [DEFAULT]=thick_flat10=100 [A]
+    double thick_flat10;
+
+    //  [DEFAULT]=func_inter1=0
+    double func_inter1;
+    //  [DEFAULT]=func_inter2=0
+    double func_inter2;
+    //  [DEFAULT]=func_inter3=0
+    double func_inter3;
+    //  [DEFAULT]=func_inter4=0
+    double func_inter4;
+    //  [DEFAULT]=func_inter5=0
+    double func_inter5;
+    //  [DEFAULT]=func_inter6=0
+    double func_inter6;
+    //  [DEFAULT]=func_inter7=0
+    double func_inter7;
+    //  [DEFAULT]=func_inter8=0
+    double func_inter8;
+    //  [DEFAULT]=func_inter9=0
+    double func_inter9;
+    //  [DEFAULT]=func_inter10=0
+    double func_inter10;
+
+    //  [DEFAULT]=nu_inter1=2.5
+    double nu_inter1;
+    //  [DEFAULT]=nu_inter2=2.5
+    double nu_inter2;
+    //  [DEFAULT]=nu_inter3=2.5
+    double nu_inter3;
+    //  [DEFAULT]=nu_inter4=2.5
+    double nu_inter4;
+    //  [DEFAULT]=nu_inter5=2.5
+    double nu_inter5;
+    //  [DEFAULT]=nu_inter6=2.5
+    double nu_inter6;
+    //  [DEFAULT]=nu_inter7=2.5
+    double nu_inter7;
+    //  [DEFAULT]=nu_inter8=2.5
+    double nu_inter8;
+    //  [DEFAULT]=nu_inter9=2.5
+    double nu_inter9;
+    //  [DEFAULT]=nu_inter10=2.5
+    double nu_inter10;
+
+    //  [DEFAULT]=npts_inter=35.0
+    double npts_inter;
+    //  [DEFAULT]=nu_inter0=2.5
+    double nu_inter0;
+    //  [DEFAULT]=rad_core0=50.0 [A]
+    double rad_core0;
+} SphereSLDParameters;
+
+double sphere_sld_kernel(double dq[], double q);
+
+/// 1D scattering function
+double sphere_sld_analytical_1D(SphereSLDParameters *pars, double q);
+
+/// 2D scattering function
+double sphere_sld_analytical_2D(SphereSLDParameters *pars, double q, double phi);
+double sphere_sld_analytical_2DXY(SphereSLDParameters *pars, double qx, double qy);
+
+#endif
Index: sansmodels/src/sans/models/c_models/CReflModel.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/CReflModel.cpp	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_models/CReflModel.cpp	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -90,10 +90,6 @@
         
         // Initialize parameter dictionary
-        PyDict_SetItemString(self->params,"sldIM_flat4",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"thick_flat8",Py_BuildValue("d",100.000000000000));
         PyDict_SetItemString(self->params,"thick_flat9",Py_BuildValue("d",100.000000000000));
-        PyDict_SetItemString(self->params,"sldIM_flat7",Py_BuildValue("d",0.000000000000));
-        PyDict_SetItemString(self->params,"sldIM_flat10",Py_BuildValue("d",0.000000000000));
-        PyDict_SetItemString(self->params,"sldIM_flat5",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"thick_flat1",Py_BuildValue("d",10.000000000000));
         PyDict_SetItemString(self->params,"thick_flat3",Py_BuildValue("d",100.000000000000));
@@ -103,7 +99,7 @@
         PyDict_SetItemString(self->params,"thick_flat4",Py_BuildValue("d",100.000000000000));
         PyDict_SetItemString(self->params,"thick_flat5",Py_BuildValue("d",100.000000000000));
-        PyDict_SetItemString(self->params,"sld_sub0",Py_BuildValue("d",0.000002070000));
+        PyDict_SetItemString(self->params,"thick_inter0",Py_BuildValue("d",1.000000000000));
         PyDict_SetItemString(self->params,"thick_inter1",Py_BuildValue("d",1.000000000000));
-        PyDict_SetItemString(self->params,"thick_inter2",Py_BuildValue("d",1.000000000000));
+        PyDict_SetItemString(self->params,"sld_bottom0",Py_BuildValue("d",0.000002070000));
         PyDict_SetItemString(self->params,"thick_inter3",Py_BuildValue("d",1.000000000000));
         PyDict_SetItemString(self->params,"thick_inter4",Py_BuildValue("d",1.000000000000));
@@ -113,10 +109,7 @@
         PyDict_SetItemString(self->params,"thick_inter8",Py_BuildValue("d",1.000000000000));
         PyDict_SetItemString(self->params,"thick_inter9",Py_BuildValue("d",1.000000000000));
-        PyDict_SetItemString(self->params,"sldIM_flat1",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"scale",Py_BuildValue("d",1.000000000000));
-        PyDict_SetItemString(self->params,"sldIM_flat2",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"func_inter9",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"thick_inter10",Py_BuildValue("d",1.000000000000));
-        PyDict_SetItemString(self->params,"sldIM_flat3",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"func_inter8",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"thick_flat2",Py_BuildValue("d",100.000000000000));
@@ -136,16 +129,11 @@
         PyDict_SetItemString(self->params,"sld_flat2",Py_BuildValue("d",0.000003500000));
         PyDict_SetItemString(self->params,"sld_flat3",Py_BuildValue("d",0.000004000000));
-        PyDict_SetItemString(self->params,"sldIM_flat8",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"sld_flat8",Py_BuildValue("d",0.000003500000));
         PyDict_SetItemString(self->params,"sld_flat9",Py_BuildValue("d",0.000004000000));
-        PyDict_SetItemString(self->params,"sldIM_flat9",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"background",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"func_inter1",Py_BuildValue("d",0.000000000000));
-        PyDict_SetItemString(self->params,"sldIM_sub0",Py_BuildValue("d",0.000000000000));
-        PyDict_SetItemString(self->params,"sldIM_medium",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"sld_flat10",Py_BuildValue("d",0.000003500000));
-        PyDict_SetItemString(self->params,"thick_inter0",Py_BuildValue("d",1.000000000000));
-        PyDict_SetItemString(self->params,"sldIM_flat6",Py_BuildValue("d",0.000000000000));
         PyDict_SetItemString(self->params,"func_inter4",Py_BuildValue("d",0.000000000000));
+        PyDict_SetItemString(self->params,"thick_inter2",Py_BuildValue("d",1.000000000000));
         PyDict_SetItemString(self->params,"func_inter10",Py_BuildValue("d",0.000000000000));
         // Initialize dispersion / averaging parameter dict
@@ -284,10 +272,6 @@
 	
 	    // Reader parameter dictionary
-    self->model->sldIM_flat4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat4") );
     self->model->thick_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat8") );
     self->model->thick_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat9") );
-    self->model->sldIM_flat7 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat7") );
-    self->model->sldIM_flat10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat10") );
-    self->model->sldIM_flat5 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat5") );
     self->model->thick_flat1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat1") );
     self->model->thick_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat3") );
@@ -297,7 +281,7 @@
     self->model->thick_flat4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat4") );
     self->model->thick_flat5 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat5") );
-    self->model->sld_sub0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_sub0") );
+    self->model->thick_inter0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter0") );
     self->model->thick_inter1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter1") );
-    self->model->thick_inter2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter2") );
+    self->model->sld_bottom0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_bottom0") );
     self->model->thick_inter3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter3") );
     self->model->thick_inter4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter4") );
@@ -307,10 +291,7 @@
     self->model->thick_inter8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter8") );
     self->model->thick_inter9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter9") );
-    self->model->sldIM_flat1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat1") );
     self->model->scale = PyFloat_AsDouble( PyDict_GetItemString(self->params, "scale") );
-    self->model->sldIM_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat2") );
     self->model->func_inter9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter9") );
     self->model->thick_inter10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter10") );
-    self->model->sldIM_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat3") );
     self->model->func_inter8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter8") );
     self->model->thick_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat2") );
@@ -330,16 +311,11 @@
     self->model->sld_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat2") );
     self->model->sld_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat3") );
-    self->model->sldIM_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat8") );
     self->model->sld_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat8") );
     self->model->sld_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat9") );
-    self->model->sldIM_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat9") );
     self->model->background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
     self->model->func_inter1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter1") );
-    self->model->sldIM_sub0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_sub0") );
-    self->model->sldIM_medium = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_medium") );
     self->model->sld_flat10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat10") );
-    self->model->thick_inter0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter0") );
-    self->model->sldIM_flat6 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat6") );
     self->model->func_inter4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter4") );
+    self->model->thick_inter2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter2") );
     self->model->func_inter10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter10") );
     // Read in dispersion parameters
@@ -410,10 +386,6 @@
 	
 	    // Reader parameter dictionary
-    self->model->sldIM_flat4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat4") );
     self->model->thick_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat8") );
     self->model->thick_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat9") );
-    self->model->sldIM_flat7 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat7") );
-    self->model->sldIM_flat10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat10") );
-    self->model->sldIM_flat5 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat5") );
     self->model->thick_flat1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat1") );
     self->model->thick_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat3") );
@@ -423,7 +395,7 @@
     self->model->thick_flat4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat4") );
     self->model->thick_flat5 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat5") );
-    self->model->sld_sub0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_sub0") );
+    self->model->thick_inter0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter0") );
     self->model->thick_inter1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter1") );
-    self->model->thick_inter2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter2") );
+    self->model->sld_bottom0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_bottom0") );
     self->model->thick_inter3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter3") );
     self->model->thick_inter4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter4") );
@@ -433,10 +405,7 @@
     self->model->thick_inter8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter8") );
     self->model->thick_inter9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter9") );
-    self->model->sldIM_flat1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat1") );
     self->model->scale = PyFloat_AsDouble( PyDict_GetItemString(self->params, "scale") );
-    self->model->sldIM_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat2") );
     self->model->func_inter9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter9") );
     self->model->thick_inter10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter10") );
-    self->model->sldIM_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat3") );
     self->model->func_inter8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter8") );
     self->model->thick_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat2") );
@@ -456,16 +425,11 @@
     self->model->sld_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat2") );
     self->model->sld_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat3") );
-    self->model->sldIM_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat8") );
     self->model->sld_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat8") );
     self->model->sld_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat9") );
-    self->model->sldIM_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat9") );
     self->model->background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
     self->model->func_inter1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter1") );
-    self->model->sldIM_sub0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_sub0") );
-    self->model->sldIM_medium = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_medium") );
     self->model->sld_flat10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat10") );
-    self->model->thick_inter0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter0") );
-    self->model->sldIM_flat6 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat6") );
     self->model->func_inter4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter4") );
+    self->model->thick_inter2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter2") );
     self->model->func_inter10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter10") );
     // Read in dispersion parameters
@@ -523,10 +487,6 @@
 	
 	    // Reader parameter dictionary
-    self->model->sldIM_flat4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat4") );
     self->model->thick_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat8") );
     self->model->thick_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat9") );
-    self->model->sldIM_flat7 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat7") );
-    self->model->sldIM_flat10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat10") );
-    self->model->sldIM_flat5 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat5") );
     self->model->thick_flat1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat1") );
     self->model->thick_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat3") );
@@ -536,7 +496,7 @@
     self->model->thick_flat4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat4") );
     self->model->thick_flat5 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat5") );
-    self->model->sld_sub0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_sub0") );
+    self->model->thick_inter0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter0") );
     self->model->thick_inter1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter1") );
-    self->model->thick_inter2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter2") );
+    self->model->sld_bottom0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_bottom0") );
     self->model->thick_inter3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter3") );
     self->model->thick_inter4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter4") );
@@ -546,10 +506,7 @@
     self->model->thick_inter8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter8") );
     self->model->thick_inter9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter9") );
-    self->model->sldIM_flat1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat1") );
     self->model->scale = PyFloat_AsDouble( PyDict_GetItemString(self->params, "scale") );
-    self->model->sldIM_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat2") );
     self->model->func_inter9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter9") );
     self->model->thick_inter10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter10") );
-    self->model->sldIM_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat3") );
     self->model->func_inter8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter8") );
     self->model->thick_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat2") );
@@ -569,16 +526,11 @@
     self->model->sld_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat2") );
     self->model->sld_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat3") );
-    self->model->sldIM_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat8") );
     self->model->sld_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat8") );
     self->model->sld_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat9") );
-    self->model->sldIM_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat9") );
     self->model->background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
     self->model->func_inter1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter1") );
-    self->model->sldIM_sub0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_sub0") );
-    self->model->sldIM_medium = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_medium") );
     self->model->sld_flat10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat10") );
-    self->model->thick_inter0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter0") );
-    self->model->sldIM_flat6 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat6") );
     self->model->func_inter4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter4") );
+    self->model->thick_inter2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter2") );
     self->model->func_inter10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter10") );
     // Read in dispersion parameters
@@ -605,10 +557,6 @@
 	
 	    // Reader parameter dictionary
-    self->model->sldIM_flat4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat4") );
     self->model->thick_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat8") );
     self->model->thick_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat9") );
-    self->model->sldIM_flat7 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat7") );
-    self->model->sldIM_flat10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat10") );
-    self->model->sldIM_flat5 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat5") );
     self->model->thick_flat1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat1") );
     self->model->thick_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat3") );
@@ -618,7 +566,7 @@
     self->model->thick_flat4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat4") );
     self->model->thick_flat5 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat5") );
-    self->model->sld_sub0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_sub0") );
+    self->model->thick_inter0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter0") );
     self->model->thick_inter1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter1") );
-    self->model->thick_inter2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter2") );
+    self->model->sld_bottom0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_bottom0") );
     self->model->thick_inter3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter3") );
     self->model->thick_inter4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter4") );
@@ -628,10 +576,7 @@
     self->model->thick_inter8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter8") );
     self->model->thick_inter9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter9") );
-    self->model->sldIM_flat1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat1") );
     self->model->scale = PyFloat_AsDouble( PyDict_GetItemString(self->params, "scale") );
-    self->model->sldIM_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat2") );
     self->model->func_inter9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter9") );
     self->model->thick_inter10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter10") );
-    self->model->sldIM_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat3") );
     self->model->func_inter8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter8") );
     self->model->thick_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_flat2") );
@@ -651,16 +596,11 @@
     self->model->sld_flat2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat2") );
     self->model->sld_flat3 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat3") );
-    self->model->sldIM_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat8") );
     self->model->sld_flat8 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat8") );
     self->model->sld_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat9") );
-    self->model->sldIM_flat9 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat9") );
     self->model->background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
     self->model->func_inter1 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter1") );
-    self->model->sldIM_sub0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_sub0") );
-    self->model->sldIM_medium = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_medium") );
     self->model->sld_flat10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sld_flat10") );
-    self->model->thick_inter0 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter0") );
-    self->model->sldIM_flat6 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "sldIM_flat6") );
     self->model->func_inter4 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter4") );
+    self->model->thick_inter2 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "thick_inter2") );
     self->model->func_inter10 = PyFloat_AsDouble( PyDict_GetItemString(self->params, "func_inter10") );
     // Read in dispersion parameters
Index: sansmodels/src/sans/models/c_models/refl.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/refl.cpp	(revision 339ce675656e3ab89eff7b84d8292a2e0ffe6109)
+++ sansmodels/src/sans/models/c_models/refl.cpp	(revision 0164899a491d20467a714225f7ea955c852265f3)
@@ -15,5 +15,5 @@
 	thick_inter0 = Parameter(1.0);
 	func_inter0 = Parameter(0);
-	sld_sub0 = Parameter(2.07e-06);
+	sld_bottom0 = Parameter(2.07e-06);
 	sld_medium = Parameter(1.0e-06);
     background = Parameter(0.0);
@@ -67,17 +67,4 @@
     func_inter10 = Parameter(0);
 
-    sldIM_flat1 = Parameter(0);
-    sldIM_flat2 = Parameter(0);
-    sldIM_flat3 = Parameter(0);
-    sldIM_flat4 = Parameter(0);
-    sldIM_flat5 = Parameter(0);
-    sldIM_flat6 = Parameter(0);
-    sldIM_flat7 = Parameter(0);
-    sldIM_flat8 = Parameter(0);
-    sldIM_flat9 = Parameter(0);
-    sldIM_flat10 = Parameter(0);
-
-    sldIM_sub0 = Parameter(0);
-    sldIM_medium = Parameter(0);
 }
 
@@ -88,5 +75,5 @@
  */
 double ReflModel :: operator()(double q) {
-	double dp[59];
+	double dp[47];
 	// Fill parameter array for IGOR library
 	// Add the background after averaging
@@ -95,5 +82,5 @@
 	dp[2] = thick_inter0();
 	dp[3] = func_inter0();
-	dp[4] = sld_sub0();
+	dp[4] = sld_bottom0();
 	dp[5] = sld_medium();
 	dp[6] = background();
@@ -143,18 +130,4 @@
 	dp[46] = func_inter10();
 
-	dp[47] = sldIM_flat1();
-	dp[48] = sldIM_flat2();
-	dp[49] = sldIM_flat3();
-	dp[50] = sldIM_flat4();
-	dp[51] = sldIM_flat5();
-	dp[52] = sldIM_flat6();
-	dp[53] = sldIM_flat7();
-	dp[54] = sldIM_flat8();
-	dp[55] = sldIM_flat9();
-	dp[56] = sldIM_flat10();
-
-	dp[57] = sldIM_sub0();
-	dp[58] = sldIM_medium();
-
 	// Get the dispersion points for the radius
 	//vector<WeightPoint> weights_thick;
